.kaniko-build:
  image:
    name: gcr.io/kaniko-project/executor:debug
    entrypoint: [""]
  stage: build
  variables:
    DESTINATION_LATEST: ""
  before_script:
    - DOCKER_TAG="latest"
    - |
      DOCKER_REGISTRY_IMAGE_TAG="$DOCKER_REGISTRY_IMAGE:$DOCKER_TAG"
      echo $DOCKER_REGISTRY_IMAGE_TAG
      if [ -n "$CI_COMMIT_TAG" ]; then
        DESTINATION_LATEST="--destination $DOCKER_REGISTRY_IMAGE:latest"
      fi
    - |
      mkdir -p /kaniko/.docker
      echo "{\"auths\":{\"$CI_REGISTRY\":{\"auth\":\"$(echo -n ${CI_REGISTRY_USER}:${CI_REGISTRY_PASSWORD} | base64 | tr -d '\n')\"}}}" \
        > /kaniko/.docker/config.json
  script:
    - |
      /kaniko/executor \
        --context $CONTEXT_PATH \
        --dockerfile $DOCKERFILE_PATH \
        --destination $DOCKER_REGISTRY_IMAGE_TAG $DESTINATION_LATEST

build:kaniko:
  extends: .kaniko-build
  variables:
    CONTEXT_PATH: $CI_PROJECT_DIR
    DOCKERFILE_PATH: $CI_PROJECT_DIR/Dockerfile
    DOCKER_REGISTRY_IMAGE: $CI_REGISTRY_IMAGE
  before_script:
    - !reference [.kaniko-build, before_script]
